unit Unit1;

{$MODE objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, woprspell,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  Sp: THunspell;
  Hyp: THyphen;

implementation

{ TForm1 }

procedure TForm1.Button5Click(Sender: TObject);
var AList: TList;
  i, a, b: integer;
begin
  Memo2.text := Hyp.Hyphenate(Edit1.Text);
  AList := TList.Create;
  Hyp.Hyphenate(Edit1.text, AList);
  a := 1;
  for i := 0 to AList.Count - 1 do
  begin
    Memo3.Lines.Add(Inttostr(PtrUint(AList[i])));
    b := PtrUint(AList[i]);
    Memo2.Lines.Add(Copy(Edit1.text, a, b - a + 1));
    a := b + 1;
  end;
  Memo2.Lines.Add(Copy(Edit1.text, a, Length(Edit1.text)));
  Alist.free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Sp.Add(Edit1.text);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if not Sp.Spell(Edit1.text) then
  begin
    Memo1.Lines.BeginUpdate;
    Sp.Suggest(Edit1.Text, Memo1.lines);
    Memo1.Lines.EndUpdate;
  end else Memo1.Lines.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
var p: string;
begin
  p := ExtractFilePath(Application.ExeName);
  Sp := THunspell.Create(p + 'de_DE_frami.aff', p + 'de_DE_frami.dic', p + 'libhunspell-1.2.so.0.0.0');
  Hyp := THyphen.Create(p + 'hyph_de_DE.dic', p + 'libhyphen.so.0.2.0');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Hyp.free;
  Sp.free;
end;

initialization
  {$I unit1.lrs}

end.
